from game import *
from crash import *
import math
import random

image_player = [image('penguin_left.png'), image('penguin_right.png')]
image_block = image('block.png')

SW, SH = 1, 9/16
gravity = 0.001

def hit_block(m):
    for b in group(block):
        dx, dy = m.x-b.x, m.y-b.y
        ax, ay = abs(dx), abs(dy)
        sx, sy = m.sx+b.sx, m.sy+b.sy
        if m != b and b.state == 0 and ax < sx and ay < sy:
            if ax < b.sx and ay < b.sy:
                new_crash(m.x, m.y, 0.01, 20, 0.98)
                m.life = 0
            if ay < sy*0.6:
                m.vx = 0
                m.x = b.x+math.copysign(sx, dx)
            if ax < sx*0.8:
                m.vy = 0
                m.y = b.y+math.copysign(sy, dy)

def player(p):
    p.vx = 0
    if key(LEFT):
        p.vx, p.ox = -0.01, -1
        p.image = image_player[0]
    if key(RIGHT):
        p.vx, p.ox = 0.01, 1
        p.image = image_player[1]
    p.vy -= gravity
    p.x += p.vx
    p.y += p.vy
    hit_block(p)
    if abs(p.x) > SW+p.sx or abs(p.y) > SH+p.sy:
        new_crash(p.x, p.y, 0.01, 20, 0.98)
        p.life = 0

def block(b):
    pass

def start():
    add(player, image_player[0], 0.05, 0, -0.3, ox=-1)
    for i in range(-2, 3):
        add(block, image_block, 0.05, i*0.1, -0.4)
    add(block, image_block, 0.05, 0.2, -0.3)
    add(block, image_block, 0.05, -0.2, -0.3)

run(start, 1280, 720)
