from game import *
from crash import *
import math
import random

image_player = image('player_spaceship.png')
image_enemy = image('enemy_spaceship.png')
image_bullet = image('bullet.png')

SW, SH = 1, 9/16

def player(p):
    v = 0.01
    if key(LEFT):
        p.x -= v
    if key(RIGHT):
        p.x += v
    if key(UP):
        p.y += v
    if key(DOWN):
        p.y -= v
    p.x = max(-SW+p.sx, min(SW-p.sx, p.x))
    p.y = max(-SH+p.sy, min(SH-p.sy, p.y))
    for b in group(bullet):
        d = math.dist((p.x, p.y), (b.x, b.y))
        if d < p.sx*0.5:
            new_crash(p.x, p.y, 0.01, 20, 0.98)
            p.life = 0

def bullet(b):
    b.x += b.vx
    b.y += b.vy
    b.r += 0.01
    if abs(b.x) > SW+b.sx or abs(b.y) > SH+b.sy:
        b.life = 0

def new_dir(x, y, v, dir):
    rad = dir*math.pi*2
    vx = math.cos(rad)*v
    vy = math.sin(rad)*v
    add(bullet, image_bullet, 0.03, x, y, vx, vy)

def new_nway(x, y, v, dir, n, angle):
    if n > 1:
        for i in range(n):
            new_dir(x, y, v, dir+angle/(n-1)*(i-(n-1)/2))

def enemy(e):
    if random.random() < 0.1:
        new_nway(e.x, e.y, 0.01, random.random(), 5, 0.2)

def start():
    add(player, image_player, 0.08, -0.9, 0)
    add(enemy, image_enemy, 0.08, 0, 0)

run(start, 1280, 720)
