from game import *
from crash import *
import math
import random

image_player = image('player_spaceship.png')
image_enemy = image('enemy_spaceship.png')
image_homing = image('homing.png')

SW, SH = 1, 9/16

def player(p):
    v = 0.01
    if key(LEFT):
        p.x -= v
    if key(RIGHT):
        p.x += v
    if key(UP):
        p.y += v
    if key(DOWN):
        p.y -= v
    p.x = max(-SW+p.sx, min(SW-p.sx, p.x))
    p.y = max(-SH+p.sy, min(SH-p.sy, p.y))
    for b in group(homing):
        d = math.dist((p.x, p.y), (b.x, b.y))
        if d < p.sx*0.5:
            new_crash(p.x, p.y, 0.01, 20, 0.98)
            p.life = 0

def homing(b):
    vdir = math.atan2(b.vy, b.vx)/math.pi/2
    for p in group(player):
        pdir = math.atan2(p.y-b.y, p.x-b.x)/math.pi/2
        if vdir-pdir > 0.5:
            pdir += 1
        if pdir-vdir > 0.5:
            pdir -= 1
        d = math.dist((b.x, b.y), (p.x, p.y))
        vdir += (pdir-vdir)*min(0.05, d*0.1)
        v = math.dist((b.vx, b.vy), (0, 0))
        rad = vdir*math.pi*2
        b.vx = math.cos(rad)*v
        b.vy = math.sin(rad)*v
    b.x += b.vx
    b.y += b.vy
    b.r = vdir
    if abs(b.x) > SW+b.sx or abs(b.y) > SH+b.sy:
        b.life = 0

def enemy(e):
    if random.random() < 0.02:
        add(homing, image_homing, 0.05, e.x, e.y, -0.01, 0)

def start():
    add(player, image_player, 0.08, -0.9, 0)
    add(enemy, image_enemy, 0.08, 0, 0)

run(start, 1280, 720)
