from game import *
from crash import *
import math
import random
import re

image_player = image('bear.png')
image_enemy = image('panda.png')
image_weapon = image('bear_weapon.png')
image_bullet = image('panda_bullet.png')

SW, SH = 1, 9/16

def player(p):
    for b in group(bullet):
        d = math.dist((b.x, b.y), (p.x, p.y))
        if d < 0.2:
            if key(LEFT) and not key(RIGHT) and p.state == 0:
                new_crash(b.x, b.y, 0.01, 10, 0.95)
                b.life = 0
            else:
                new_crash(p.x, p.y, 0.01, 20, 0.98)
                p.life = 0
    if key(LEFT) and not key(RIGHT):
        p.r += (0.05-p.r)*0.2
    else:
        p.r += (0-p.r)*0.2

def enemy(e):
    if random.random()<0.02:
        if random.random()<0.5:
            add(bullet, image_bullet, 0.1, 
                e.x-0.1, e.y+0.03, -0.01, 0)
        else:
            add(bullet, image_bullet, 0.1, 
                e.x-0.1, e.y-0.15, -0.01, 0)

def bullet(b):
    b.x += b.vx
    b.r += 0.01
    if abs(b.x) > SW+b.sx:
        b.life = 0

def start():
    add(player, image_player, 0.2, -0.7, 0, sy=0.3)
    add(enemy, image_enemy, 0.2, 0.7, 0, sy=0.3)

run(start, 1280, 720)
