from game import *
from crash import *
import math
import random

image_player = [
    image('eater0.png'), image('eater1.png'), image('eater2.png')]
image_enemy = [
    image('ghost0.png'), image('ghost1.png'), image('ghost2.png')]
image_wall = image('wall.png')
image_bait = image('bait.png')

def walk(m, vx, vy, turn):
    m.x += vx
    m.y += vy
    for w in group(wall):
        dx, dy = m.x-w.x, m.y-w.y
        ax, ay = abs(dx), abs(dy)
        sx, sy = m.sx+w.sx, m.sy+w.sy
        tx, ty = sx*turn, sy*turn
        if ax < sx and ay < sy:
            if vx*dx < 0 and ay <= ty or vy and ax > tx:
                vx = 0
                m.x = w.x+math.copysign(sx, dx)
            if vy*dy < 0 and ax <= tx or vx and ay > ty:
                vy = 0
                m.y = w.y+math.copysign(sy, dy)
    return vx or vy

def player(p):
    v = 0.01
    vx = vy = 0
    if key(LEFT):
        vx, r = -v, 0.5
    elif key(RIGHT):
        vx, r = v, 0
    elif key(UP):
        vy, r = v, 0.25
    elif key(DOWN):
        vy, r = -v, 0.75
    x, y = p.x, p.y
    if walk(p, vx, vy, 0.85):
        p.vx, p.vy = vx, vy
        p.r = r
    else:
        p.x, p.y = x, y
        walk(p, p.vx, p.vy, 0.85)
    if p.x != x or p.y != y:
        p.time += 1
        anim = [0, 1, 2, 1]
        p.image = image_player[anim[p.time//3%len(anim)]];

def enemy(e):
    pass

def wall(w):
    pass

def bait(b):
    pass

maze =[
    '###################',
    '#........#........#',
    '#.##.###.#.###.##.#',
    '#........0........#',
    '####.#.#####.#.####',
    '#.1..#...#...#..2.#',
    '#.##.###.#.###.##.#',
    '#.#..#...#...#..#.#',
    '#.#.##.#####.##.#.#',
    '#........P........#',
    '###################',
]

def start():
    table = {
        'P':(player, image_player[0]), 
        '0':(enemy, image_enemy[0]), 
        '1':(enemy, image_enemy[1]), 
        '2':(enemy, image_enemy[2]), 
        '#':(wall, image_wall), 
        '.':(bait, image_bait), 
    }
    size = 0.05
    for ri, row in enumerate(maze):
        for ci, cell in enumerate(row):
            x = (ci-(len(row)-1)/2)*size*2
            y = ((len(maze)-1)/2-ri)*size*2+size*0.3
            func, image = table[cell]
            add(func, image, size, x, y)

run(start, 1280, 720)
